scoreboard objectives add tempKillMob dummy
scoreboard players operation @p[tag=highestprogress] tempKillMob = @p[tag=highestprogress] progress
scoreboard players add @p[tag=highestprogress] tempKillMob 1
execute as @e[type=interactable:door,tag=P1] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=P2] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=P3] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=LeB] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=LeL] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=LeB2] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=LeC] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=LeW] if score @s door_number = @p[tag=highestprogress] tempKillMob run event entity @e[family=running_monster] ae:despawns
execute as @e[type=interactable:door,tag=CH] run event entity @e[family=running_monster] ae:despawns
scoreboard objectives remove tempKillMob

execute as @e[type=interactable:door] at @s if block ~ ~1 ~ barrier [] run setblock ~ ~1 ~ air
execute as @e[type=interactable:door] at @s if block ^1 ^1 ^ barrier [] run setblock ^1 ^1 ^ air
execute as @e[type=interactable:door] at @s if block ^-1 ^1 ^ barrier [] run setblock ^-1 ^1 ^ air
execute as @e[type=ae:normal_door] at @s if block ~ ~1 ~ barrier [] run setblock ~ ~1 ~ air
execute as @e[type=ae:normal_door] at @s if block ^1 ^1 ^ barrier [] run setblock ^1 ^1 ^ air
execute as @e[type=ae:normal_door] at @s if block ^-1 ^1 ^ barrier [] run setblock ^-1 ^1 ^ air

execute if entity @e[type=ae:rush] if entity @e[type=ae:ambush] run event entity @e[type=ae:ambush] ae:despawns
execute if entity @e[type=ae:the_lost_souls] if entity @e[type=ae:ambush] run event entity @e[type=ae:ambush] ae:despawns
execute if entity @e[type=ae:the_lost_souls] if entity @e[type=ae:rush] run event entity @e[type=ae:rush] ae:despawns

execute as @e[type=interactable:door,c=1,tag=boss] at @s run function door/lock

execute as @e[type=interactable:door] at @s unless entity @e[type=ae:ride_door,r=2,c=1] run ride @s summon_rider ae:ride_door

tag @a remove hide
execute as @a[x=0,y=101,z=0,rm=20] at @s unless entity @e[type=ae:wardrobe,r=0.8,c=1] unless entity @e[type=ae:custom_bed,r=0.8,c=1] run tag @s remove first_hider
execute as @e[type=ae:wardrobe,x=0,y=101,z=0,rm=20] at @s unless entity @p[r=0.8,tag=first_hider] if entity @p[r=0.8] run tag @p[r=0.8,c=1] add first_hider
execute as @e[type=ae:custom_bed,x=0,y=101,z=0,rm=20] at @s unless entity @p[r=0.8,tag=first_hider] if entity @p[r=0.8] run tag @p[r=0.8,c=1] add first_hider
tag @a[tag=first_hider,x=0,y=101,z=0,rm=20] add hide

scoreboard objectives add alreadyspawned dummy
execute as @p at @s as @a[x=0,y=207,z=0,r=3,scores={alreadyspawned=1}] run function mechanics/monsters/kill_tag/darkness
execute as @p[scores={alreadyspawned=0}] run function mechanics/joined_to_spawn

execute if score popup delay matches 1.. run scoreboard players add popup delay -1
execute in overworld if score popup delay matches 1 as @p run function purchases/popup

scoreboard objectives add popup_again dummy
execute if score popup_again delay matches 1.. run scoreboard players add popup_again delay -1
execute in overworld if score popup_again delay matches 1 as @p run function purchases/popup_again

execute as @e[type=ae:wardrobe] at @s run setblock ~ ~ ~ light_block ["block_light_level":4]

execute as @a[scores={door_click=1}] at @s as @e[type=interactable:door,r=5,c=1,tag=!LeB,tag=!LeL] at @s unless entity @e[type=ae:padlock,r=4] run function door/open_closest_door
execute as @a[scores={door_click=1}] at @s as @e[type=interactable:door,r=5,c=1] at @s unless entity @e[type=ae:padlock,r=4] run scoreboard players set @s door_click 0

execute if block 0 10 0 air [] if block -5 102 -9 lever ["lever_direction":"south","open_bit":true] run tellraw @a {"rawtext":[{"translate":"text.visual_prompts_on"}]}
execute if block 0 10 0 air [] if block -5 102 -9 lever ["lever_direction":"south","open_bit":true] run setblock 0 10 0 concrete ["color":"green"]

execute if block 0 10 0 concrete ["color":"green"] if block -5 102 -9 lever ["lever_direction":"south","open_bit":false] run tellraw @a {"rawtext":[{"translate":"text.visual_prompts_off"}]}
execute if block 0 10 0 concrete ["color":"green"] if block -5 102 -9 lever ["lever_direction":"south","open_bit":false] run setblock 0 10 0 air []

scoreboard objectives add door_click dummy

scoreboard players add @a alreadyspawned 0





scoreboard objectives add twoinoneblock dummy
scoreboard players set @e[type=interactable:door] twoinoneblock 0
execute as @e[type=interactable:door] at @s run scoreboard players add @e[type=interactable:door,r=2] twoinoneblock 1
tag @e[type=interactable:door,scores={twoinoneblock=2..}] add highestinstack
scoreboard players add @e[type=interactable:door,scores={twoinoneblock=2..}] door_number 0
execute as @e[type=interactable:door,scores={twoinoneblock=2..}] at @s as @e[type=interactable:door,scores={twoinoneblock=2..},r=2] if score @s door_number < @e[type=interactable:door,c=1] door_number run tag @s remove highestinstack
event entity @e[type=interactable:door,scores={twoinoneblock=2..},tag=!highestinstack] ae:despawns

scoreboard objectives add noduplicates dummy
scoreboard players add @e[type=interactable:door] noduplicates 0

execute as @p if entity @e[x=0,y=600,z=100,r=2] run event entity @e[x=0,y=600,z=100,r=2] ae:despawns
execute as @p if entity @e[x=0,y=600,z=100,r=2] run kill @e[x=0,y=600,z=100,r=2]

execute as @e[scores={keyFailsafeDelay=1}] unless entity @s[hasitem={item=ae:key}] at @s run function mechanics/padlock/spawnkeyrandom
scoreboard players add @e[scores={keyFailsafeDelay=1..}] keyFailsafeDelay -1