# Puzzle 1 - Note Blocks
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"] 
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] positioned ^-8^-3^8 run function mechanics/puzzle/1/random_note
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] positioned ^-8^-3^10 run function mechanics/puzzle/1/random_note
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] positioned ^-8^-3^12 run function mechanics/puzzle/1/random_note
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] positioned ^-8^-3^14 run function mechanics/puzzle/1/random_note
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] unless entity @e[type=ae:padlock,r=4] run summon ae:padlock ^-0.5 ^ ^0.8
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] positioned as @e[type=ae:padlock,r=4,c=1] run tp @e[type=ae:padlock,r=1,c=1] ~ ~ ~ facing ^ ^ ^5
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]

execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if blocks ^-9^^8 ^-9^^8 ^-8^-3^8 all if blocks ^-9^^10 ^-9^^10 ^-8^-3^10 all if blocks ^-9^^12 ^-9^^12 ^-8^-3^12 all if blocks ^-9^^14 ^-9^^14 ^-8^-3^14 all run function mechanics/puzzle/1/solved

execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] if blocks ^-9^^8 ^-9^^8 ^-8^-3^8 all run setblock ^-8^-1^8 stained_glass ["color":"lime"]
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] if blocks ^-9^^10 ^-9^^10 ^-8^-3^10 all run setblock ^-8^-1^10 stained_glass ["color":"lime"]
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] if blocks ^-9^^12 ^-9^^12 ^-8^-3^12 all run setblock ^-8^-1^12 stained_glass ["color":"lime"]
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] if blocks ^-9^^14 ^-9^^14 ^-8^-3^14 all run setblock ^-8^-1^14 stained_glass ["color":"lime"]

execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] unless blocks ^-9^^8 ^-9^^8 ^-8^-3^8 all run setblock ^-8^-1^8 glass []
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] unless blocks ^-9^^10 ^-9^^10 ^-8^-3^10 all run setblock ^-8^-1^10 glass []
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] unless blocks ^-9^^12 ^-9^^12 ^-8^-3^12 all run setblock ^-8^-1^12 glass []
execute as @e[type=interactable:door,tag=P1] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] unless blocks ^-9^^14 ^-9^^14 ^-8^-3^14 all run setblock ^-8^-1^14 glass []

scoreboard objectives add NOTE_PLAY dummy
execute as @e[type=interactable:door,tag=P1,tag=!NOTE_PLAY] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] run scoreboard players set @s NOTE_PLAY 180
execute as @e[type=interactable:door,tag=P1,tag=!NOTE_PLAY] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if block ^-11^1^11 lit_redstone_lamp [] run tag @s add NOTE_PLAY
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=..94}] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run scoreboard players reset NOTE_PLAY
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=..94}] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run tag @s remove NOTE_PLAY
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=95..}] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run scoreboard players add @s NOTE_PLAY -1
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=175..180}] at @s positioned ^-0.2^^ run fill ^-8^-3^8 ^-11^^14 air [] replace redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=155..175}] at @s positioned ^-0.2^^ run setblock ^-9^-3^14 redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=155..175}] at @s positioned ^-0.2^^ run setblock ^-10^^14 redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=135..155}] at @s positioned ^-0.2^^ run setblock ^-9^-3^12 redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=135..155}] at @s positioned ^-0.2^^ run setblock ^-10^^12 redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=115..135}] at @s positioned ^-0.2^^ run setblock ^-9^-3^10 redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=115..135}] at @s positioned ^-0.2^^ run setblock ^-10^^10 redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=95..115}] at @s positioned ^-0.2^^ run setblock ^-9^-3^8 redstone_block
execute as @e[type=interactable:door,tag=P1,scores={NOTE_PLAY=95..115}] at @s positioned ^-0.2^^ run setblock ^-10^^8 redstone_block



# Puzzle 2 - Office
execute as @e[type=interactable:door,tag=P2] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"] 
execute as @e[type=interactable:door,tag=P2] at @s align xyz positioned ~0.5 ~ ~0.5 if block ~ ~20 ~ concrete ["color":"white"] run function mechanics/puzzle/2/hide_book
execute as @e[type=interactable:door,tag=P2] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] unless entity @e[type=ae:padlock,r=4] run summon ae:padlock ^-0.5 ^ ^0.8
execute as @e[type=interactable:door,tag=P2] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] positioned as @e[type=ae:padlock,r=4,c=1] run tp @e[type=ae:padlock,r=1,c=1] ~ ~ ~ facing ^ ^ ^5
execute as @e[type=interactable:door,tag=P2] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]

execute as @e[type=interactable:door,tag=P2] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if entity @p[r=20,hasitem={item=enchanted_book}] run function mechanics/puzzle/2/solved


# Puzzle 3 - Kitchen
execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"] 
execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ align xyz positioned ~0.5 ~ ~0.5 if block ~ ~20 ~ concrete ["color":"white"] run function mechanics/puzzle/3/hide_items
execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] unless entity @e[type=ae:padlock,r=4] run summon ae:padlock ^-0.5 ^ ^0.8
execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] positioned as @e[type=ae:padlock,r=4,c=1] run tp @e[type=ae:padlock,r=1,c=1] ~ ~ ~ facing ^ ^ ^5
execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]

execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"lime"] run clear @a[r=30] web
execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run clear @a[r=30] web
execute as @e[type=interactable:door,tag=P3] at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] if entity @p[r=20,hasitem={item=cooked_porkchop}] run function mechanics/puzzle/3/solved







# Lever - Library
execute as @e[type=interactable:door,tag=LeL] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"]
scoreboard players add @e[type=interactable:door,tag=LeL] random_lever 0 
execute as @e[type=interactable:door,tag=LeL] unless score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run function mechanics/puzzle/LeL/spawn
execute as @e[type=interactable:door,tag=LeL] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]
execute as @e[type=interactable:door,tag=LeL] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run function mechanics/puzzle/LeL/check

# Lever - Basement
execute as @e[type=interactable:door,tag=LeB] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"]
scoreboard players add @e[type=interactable:door,tag=LeB] random_lever 0
execute as @e[type=interactable:door,tag=LeB] unless score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run function mechanics/puzzle/LeB/spawn
execute as @e[type=interactable:door,tag=LeB] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]
execute as @e[type=interactable:door,tag=LeB] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run function mechanics/puzzle/LeB/check

# Lever - Basement 2
execute as @e[type=interactable:door,tag=LeB2] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"]
scoreboard players add @e[type=interactable:door,tag=LeB2] random_lever 0
execute as @e[type=interactable:door,tag=LeB2] unless score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run function mechanics/puzzle/LeB2/spawn
execute as @e[type=interactable:door,tag=LeB2] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]
execute as @e[type=interactable:door,tag=LeB2] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run function mechanics/puzzle/LeB2/check

# Lever - Ward
execute as @e[type=interactable:door,tag=LeW] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"]
scoreboard players add @e[type=interactable:door,tag=LeW] random_lever 0
execute as @e[type=interactable:door,tag=LeW] unless score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run function mechanics/puzzle/LeW/spawn
execute as @e[type=interactable:door,tag=LeW] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]
execute as @e[type=interactable:door,tag=LeW] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run function mechanics/puzzle/LeW/check

# Lever - Crate
execute as @e[type=interactable:door,tag=LeC] at @s positioned ^-0.2^^ if block ~ ~20 ~ air [] run setblock ~ ~20 ~ concrete ["color":"white"]
scoreboard players add @e[type=interactable:door,tag=LeC] random_lever 0
execute as @e[type=interactable:door,tag=LeC] unless score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run function mechanics/puzzle/LeC/spawn
execute as @e[type=interactable:door,tag=LeC] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"white"] run setblock ~ ~20 ~ concrete ["color":"red"]
execute as @e[type=interactable:door,tag=LeC] if score @s random_lever matches 1.. at @s positioned ^-0.2^^ if block ~ ~20 ~ concrete ["color":"red"] run function mechanics/puzzle/LeC/check
