function mechanics/generate/decrease_intervals

tag @e[c=1,type=interactable:door] add generator


tag @a remove scoreboarddummy
tag @r add scoreboarddummy

# Puzzle Spawn
execute as @r if score forceGen generator matches 0 if score puzzle interval_rooms matches 1.. run scoreboard players remove puzzle interval_rooms 1
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation @p[tag=scoreboarddummy] interval_rooms = puzzle interval_rooms
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] run scoreboard players set forceGen generator 3

# Lever Spawn
execute as @r if score forceGen generator matches 0 if score lever interval_rooms matches 1.. run scoreboard players remove lever interval_rooms 1
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation @p[tag=scoreboarddummy] interval_rooms = lever interval_rooms
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] run scoreboard players set forceGen generator 4

# 50-55 if gen is 2
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation temp_next_number generator = next_number generator
scoreboard players add temp_next_number generator -1
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 100.. run scoreboard players add temp_next_number generator -100
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 100.. run scoreboard players add temp_next_number generator -100
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 100.. run scoreboard players add temp_next_number generator -100
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 100.. run scoreboard players add temp_next_number generator -100
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 50 run scoreboard players set forceGen generator 2
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 50 run scoreboard players set force_random_room generator 201
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 51..54 run scoreboard players random force_random_room generator 203 208
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 55 run scoreboard players set force_random_room generator 202
execute as @p[tag=scoreboarddummy] if score temp_next_number generator matches 56 run scoreboard players set forceGen generator 0
execute as @p[tag=scoreboarddummy] run scoreboard players reset temp_next_number generator

execute as @e[c=1,type=interactable:door] at @s if score @s noduplicates matches 0 if entity @s[ry=-45,rym=-135,tag=CR] run function mechanics/generate/right/CR
execute as @e[c=1,type=interactable:door] at @s if score @s noduplicates matches 0 if entity @s[rym=135,ry=-135,tag=CR] run function mechanics/generate/fwd/CR

execute as @e[c=1,type=interactable:door] at @s if score @s noduplicates matches 0 if entity @s[ry=135,rym=45,tag=CL] run function mechanics/generate/left/CL
execute as @e[c=1,type=interactable:door] at @s if score @s noduplicates matches 0 if entity @s[rym=135,ry=-135,tag=CL] run function mechanics/generate/fwd/CL

execute as @e[c=1,type=interactable:door] at @s if score @s noduplicates matches 0 if entity @s[ry=135,rym=45,tag=!CR,tag=!CL] run function mechanics/generate/left/default
execute as @e[c=1,type=interactable:door] at @s if score @s noduplicates matches 0 if entity @s[ry=-45,rym=-135,tag=!CR,tag=!CL] run function mechanics/generate/right/default
execute as @e[c=1,type=interactable:door] at @s if score @s noduplicates matches 0 if entity @s[rym=135,ry=-135,tag=!CR,tag=!CL] run function mechanics/generate/fwd/default

# Add Padlock
tag @a remove scoreboarddummy
tag @r add scoreboarddummy
execute as @r if score forceGen generator matches 0 if score padlock interval_rooms matches 1.. run scoreboard players remove padlock interval_rooms 1
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation @p[tag=scoreboarddummy] interval_rooms = padlock interval_rooms
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] run execute as @e[tag=highestdoornum,c=-1,tag=!P1,tag=!P2,tag=!P3,tag=!LeL,tag=!LeB,tag=!LeB2,tag=!LeC,tag=!LeW,tag=!Be,tag=!CF,tag=!CH] at @s run scoreboard players set @s addpadlockdelay 5
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] if entity @e[tag=highestdoornum,c=-1,tag=!P1,tag=!P2,tag=!P3,tag=!LeL,tag=!LeB,tag=!LeB2,tag=!LeC,tag=!LeW,tag=!CF,tag=!CH] run scoreboard players random padlock interval_rooms 6 11

execute as @r if score forceGen generator matches 0 if score pssst interval_rooms matches 1.. if entity @e[type=interactable:door,tag=dark,tag=!pssstcount] run scoreboard players remove pssst interval_rooms 1
execute as @r if score forceGen generator matches 0 if score pssst interval_rooms matches 1.. if entity @e[type=interactable:door,tag=dark,tag=!pssstcount] run tag @e[type=interactable:door,tag=dark,tag=!pssstcount] add pssstcount
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation @p[tag=scoreboarddummy] interval_rooms = pssst interval_rooms
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] as @e[tag=highestdoornum,c=-1,tag=dark] at @s run function mechanics/monsters/summon_pssst
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] if entity @e[type=ae:pissst] run scoreboard players random pssst interval_rooms 2 5

execute as @r if score forceGen generator matches 0 if score rush interval_rooms matches 1.. run scoreboard players remove rush interval_rooms 1
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation @p[tag=scoreboarddummy] interval_rooms = rush interval_rooms
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] as @e[tag=highestdoornum,c=-1] at @s run function mechanics/monsters/summon_rush
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] if entity @e[type=ae:rush] run scoreboard players random rush interval_rooms 10 25


execute as @r if score forceGen generator matches 0 if score ambush interval_rooms matches 1.. run scoreboard players remove ambush interval_rooms 1
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation @p[tag=scoreboarddummy] interval_rooms = ambush interval_rooms
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] as @e[tag=highestdoornum,c=-1] at @s run function mechanics/monsters/summon_ambush
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] if entity @e[type=ae:ambush] run scoreboard players random ambush interval_rooms 20 35

execute as @r if score forceGen generator matches 0 if score lostsoul interval_rooms matches 1.. run scoreboard players remove lostsoul interval_rooms 1
scoreboard players operation @p[tag=scoreboarddummy] generator = forceGen generator
scoreboard players operation @p[tag=scoreboarddummy] interval_rooms = lostsoul interval_rooms
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] as @e[tag=highestdoornum,c=-1] at @s run function mechanics/monsters/summon_lostsoul
execute as @p[tag=scoreboarddummy,scores={generator=0,interval_rooms=0}] if entity @e[type=ae:the_lost_souls] run scoreboard players random lostsoul interval_rooms 10 25





execute if entity @e[type=interactable:door,tag=!numbered] run function mechanics/generate/numbers

tag @e[c=1,type=interactable:door] remove generator

scoreboard players reset @a generator
tellraw @a[tag=debug] {"rawtext":[{"text":"§dDebug | m/generate"}]}