execute if entity @s[tag=double_check] run function door/unlock
function mechanics/tick/darkness

scoreboard players add @a[scores={death_delay=24..}] death_delay -24
scoreboard players add @a[scores={death_delay=2..}] death_delay -1

execute if entity @p[scores={kill_mob=1}] run particle ae:death_rush -3.95 203 3.02
execute if entity @p[scores={kill_mob=2}] run particle ae:death_ambush 4.98 203 3.02
execute if entity @p[scores={kill_mob=3}] run particle ae:death_chase 4.98 203 -2.02
execute if entity @p[scores={kill_mob=4}] run particle ae:death_scab -3.95 203 -2.02
execute if entity @p[scores={kill_mob=5}] run particle ae:death_pssst 4.98 203 -7.02
execute if entity @p[scores={kill_mob=6}] run particle ae:death_darkness -3.95 203 -7.02

execute if entity @a[x=0,y=200,z=0,r=30] unless entity @a[x=0,y=100,z=0,rm=30] run function mechanics/all_dead

effect @e[family=invis] invisibility 10 10 true

effect @a saturation 5 5 true

execute if entity @r[x=0,y=100,z=0,r=30] run function mechanics/particles

scoreboard objectives add coins dummy "§l§6Coins"

scoreboard objectives remove coins_display 
scoreboard objectives add coins_display dummy "§l§6Coins"
execute as @a run scoreboard players operation @s coins_display = @s coins

scoreboard objectives setdisplay list coins_display
tp @e[type=npc,c=1] -2.44 110.00 113.51

scoreboard objectives add books dummy
scoreboard players add @a books 0
execute as @a[scores={books=0}] at @s run structure load books ~ ~ ~
execute as @a[scores={books=0}] run scoreboard players set @s books 1

effect @a[tag=hide,scores={hide_timer=360..}] nausea 1 4 true
effect @a[tag=hide,scores={hide_timer=480..}] darkness 2 5 true
effect @a[tag=hide,scores={hide_timer=540..}] poison 2 5 true
execute as @a[tag=hide,scores={hide_timer=600..}] at @s run function mechanics/monsters/kill_tag/darkness

function mechanics/kill_mob_particles

scoreboard players add @a[scores={death_delay=..1}] death_delay -1

event entity @a ae:death_false

execute if entity @p[scores={progress=0..1}] run execute as @e[type=interactable:door,x=0.0,y=100.00,z=116,r=2] at @s run function door/unlock
execute if entity @p[scores={progress=199..200}] run execute as @e[type=interactable:door,x=-3.99,y=159.00,z=116.5,r=0.5] at @s run function door/unlock

scoreboard objectives add n_progress dummy

scoreboard players set @a n_progress -100
execute as @a run scoreboard players operation @s n_progress = @s progress
scoreboard players add @a n_progress 1

scoreboard players add boss_progress progress 0

execute as @e[type=ae:custom_bookshelf] at @s if block ~ ~ ~ air [] run setblock ~ ~ ~ air []
clear @a[scores={progress=102..}] book
clear @a[x=0,y=100,z=0,r=10] book

execute as @r[type=ae:theeye,c=40] at @s if block ~ ~ ~ air [] if block ^ ^ ^-1 air [] run event entity @e[family=eyeball,r=0.5] ae:despawns

## Key Clearing System
scoreboard objectives add key_needed dummy
scoreboard players set boolean key_needed 0
execute as @e[type=interactable:door] at @s if entity @e[type=ae:ride_padlock,r=1.2] run scoreboard players set boolean key_needed 1
execute if score boolean key_needed matches 0 run clear @a ae:key

execute if entity @e[type=ae:fake_potion] if entity @e[type=ae:mad_scientist] run particle ae:potion_spot -6 184.5 67

execute as @e[family=keyspawn,tag=spawnkey] at @s unless entity @p[hasitem={item=ae:key}] unless entity @s[hasitem={item=ae:key}] run function mechanics/padlock/spawnkeyrandom