tag @e[type=ae:rush] add light_monster
tag @e[type=ae:ambush] add light_monster
tag @e[type=ae:the_lost_souls] add light_monster


execute as @e[type=ae:rush,c=1] at @r[type=ae:wall_light_on,c=10,rm=40] if block ~ ~ ~ light_block ["block_light_level":10] run setblock ~ ~ ~ light_block ["block_light_level" : 9]
execute as @e[type=ae:rush,c=1] at @r[type=ae:wall_light_on,c=10,rm=40] if block ~ ~ ~ light_block ["block_light_level":9] run setblock ~ ~ ~ light_block ["block_light_level" : 10]
execute as @e[type=ae:ambush,c=1] at @r[type=ae:wall_light_on,c=10,rm=40] if block ~ ~ ~ light_block ["block_light_level":10] run setblock ~ ~ ~ light_block ["block_light_level" : 9]
execute as @e[type=ae:ambush,c=1] at @r[type=ae:wall_light_on,c=10,rm=40] if block ~ ~ ~ light_block ["block_light_level":9] run setblock ~ ~ ~ light_block ["block_light_level" : 10]
execute as @e[type=ae:the_lost_souls,c=1] at @r[type=ae:wall_light_on,c=10,rm=40] if block ~ ~ ~ light_block ["block_light_level":10] run setblock ~ ~ ~ light_block ["block_light_level" : 9]
execute as @e[type=ae:the_lost_souls,c=1] at @r[type=ae:wall_light_on,c=10,rm=40] if block ~ ~ ~ light_block ["block_light_level":9] run setblock ~ ~ ~ light_block ["block_light_level" : 10]

scoreboard players add @e[type=ae:rush] progress 0
scoreboard players add @e[type=ae:ambush] progress 0
scoreboard players add @e[type=ae:the_lost_souls] progress 0
scoreboard players add @e[type=ae:dummy_entity] progress 0

execute unless entity @e[type=ae:rush] unless entity @e[type=ae:ambush] unless entity @e[type=ae:the_lost_souls] run event entity @e[type=ae:dummy_entity] ae:despawns 
execute as @e[type=ae:rush] at @s unless entity @e[type=ae:dummy_entity] run summon ae:dummy_entity 
execute as @e[type=ae:ambush] at @s unless entity @e[type=ae:dummy_entity] run summon ae:dummy_entity 
execute as @e[type=ae:the_lost_souls] at @s unless entity @e[type=ae:dummy_entity] run summon ae:dummy_entity 

execute as @e[type=ae:rush] at @s if score @e[type=interactable:door,r=2,c=1] door_number > @s progress run scoreboard players operation @s progress = @e[type=interactable:door,r=2] door_number 
execute as @e[type=ae:ambush] at @s if score @e[type=interactable:door,r=2,c=1] door_number > @s progress run scoreboard players operation @s progress = @e[type=interactable:door,r=2] door_number 
execute as @e[type=ae:the_lost_souls] at @s if score @e[type=interactable:door,r=2,c=1] door_number > @s progress run scoreboard players operation @s progress = @e[type=interactable:door,r=2] door_number 

scoreboard objectives add temp_monsters dummy
scoreboard players operation next_run temp_monsters = @e[type=ae:rush] progress
scoreboard players operation next_run temp_monsters = @e[type=ae:ambush] progress
scoreboard players operation next_run temp_monsters = @e[type=ae:the_lost_souls] progress
scoreboard players add next_run temp_monsters 1
scoreboard players operation @e[type=ae:dummy_entity] progress = next_run temp_monsters

scoreboard players operation above_highprog temp_monsters = @p[tag=highestprogress] progress
scoreboard players add above_highprog temp_monsters 1
execute as @e[type=ae:dummy_entity] at @s if score @s progress > above_highprog temp_monsters run event entity @e[type=ae:rush] ae:despawns
execute as @e[type=ae:dummy_entity] at @s if score @s progress > above_highprog temp_monsters run event entity @e[type=ae:ambush] ae:despawns
execute as @e[type=ae:dummy_entity] at @s if score @s progress > above_highprog temp_monsters run event entity @e[type=ae:the_lost_souls] ae:despawns

execute if score @e[type=ae:dummy_entity,c=1] progress matches 0 run scoreboard players operation @e[type=ae:dummy_entity] progress = @e[type=ae:rush,c=1] progress
execute if score @e[type=ae:dummy_entity,c=1] progress matches 0 run scoreboard players operation @e[type=ae:dummy_entity] progress = @e[type=ae:ambush,c=1] progress
execute if score @e[type=ae:dummy_entity,c=1] progress matches 0 run scoreboard players operation @e[type=ae:dummy_entity] progress = @e[type=ae:the_lost_souls,c=1] progress

execute as @e[type=ae:dummy_entity,c=1] at @s if score @s progress > @e[type=interactable:door,c=1,r=2] door_number as @e[type=interactable:door] if score @s door_number = @e[type=ae:dummy_entity,c=1] progress run tp @e[type=ae:dummy_entity,c=1] @s

execute as @e[tag=light_monster] at @s positioned ^ ^ ^60 run event entity @e[type=ae:wall_light_on,tag=!break,r=30] ae:set_break
execute as @e[tag=light_monster] at @s positioned ^ ^ ^60 run tag @e[type=ae:wall_light_on,tag=!break,r=30] add break
execute as @e[tag=light_monster] at @s run event entity @e[type=ae:wall_light_on,tag=!break,r=30] ae:set_break
execute as @e[tag=light_monster] at @s run tag @e[type=ae:wall_light_on,tag=!break,r=30] add break




#Pssst
scoreboard players add @a[scores={pssst_delay=1..}] pssst_delay -1
execute as @e[type=ae:pissst] at @s if entity @p[tag=pssst,tag=!looked_at_pssst,scores={pssst_delay=..0}] as @p[tag=pssst] run function mechanics/monsters/pssst/failed
execute as @e[type=ae:pissst] at @s if entity @p[tag=pssst,tag=looked_at_pssst,scores={pssst_delay=..0}] as @p[tag=pssst] run function mechanics/monsters/pssst/passed
execute unless entity @p[tag=pssst] run event entity @e[type=ae:pissst] ae:despawns

execute as @p[tag=pssst,scores={pssst_random=1}] at @s run tp @e[c=1,type=ae:pissst] ~-0.35 ~1.2 ~0.35
execute as @p[tag=pssst,scores={pssst_random=2}] at @s run tp @e[c=1,type=ae:pissst] ~-0.5 ~1.2 ~
execute as @p[tag=pssst,scores={pssst_random=3}] at @s run tp @e[c=1,type=ae:pissst] ~-0.35 ~1.2 ~-0.35
execute as @p[tag=pssst,scores={pssst_random=4}] at @s run tp @e[c=1,type=ae:pissst] ~ ~1.2 ~0.5
execute as @p[tag=pssst,scores={pssst_random=5}] at @s run tp @e[c=1,type=ae:pissst] ~ ~1.2 ~-0.5
execute as @p[tag=pssst,scores={pssst_random=6}] at @s run tp @e[c=1,type=ae:pissst] ~0.35 ~1.2 ~0.35
execute as @p[tag=pssst,scores={pssst_random=7}] at @s run tp @e[c=1,type=ae:pissst] ~0.5 ~1.2 ~
execute as @p[tag=pssst,scores={pssst_random=8}] at @s run tp @e[c=1,type=ae:pissst] ~0.35 ~1.2 ~-0.35

execute as @e[type=ae:pissst] at @s positioned ^ ^ ^0.5 as @p if entity @s[m=c] at @s anchored eyes positioned ^ ^-0.2 ^0.5 as @e[type=ae:pissst,r=0.1] run function pissst/look_at




## Window Monsters
execute as @e[type=ae:windows_hands] at @s run damage @a[r=6] 5 contact entity @s